import es
import cfglib
import gamethread
import popuplib
import playerlib

info = es.AddonInfo()
info.name     = 'EzProtect'
info.version  = '2.2'
info.basename = 'ezprotect'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'Wolf'
info.date     = 'September 6, 2009'

config = cfglib.AddonCFG(es.getAddonPath(info.basename) + '/' + info.basename + 'config.cfg')

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename':info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')

config.text('***** EzProtect Options *****')
cvar_serverTag        = config.cvar('cvar_serverTag', '||Wolf||', 'Set your clan or community tag. (Defailt = ||Wolf||)')
cvar_spawnProtect     = config.cvar('cvar_spawnProtect',       1, 'Turn Spawn Protect on (1=ON / 0=OFF) (Default = 1)')
cvar_spawnProtectTime = config.cvar('cvar_spawnProtectTime',  10, 'Sets the time spawn protect is on (Default = 10 Seconds)')
cvar_spawnProtectWho  = config.cvar('cvar_spawnProtectWho',    1, 'Which team gets spawn protection <1 = ALL, 2 = T, 3 = CT> (Default = 1 )')
cvar_respawn          = config.cvar('cvar_respawn',            1, 'Turn Respawn on (1 = ON / 0 = OFF) (Default = 1)')
cvar_respawnTime      = config.cvar('cvar_respawnTime',        3, 'Sets the time it takes to respawn (Default = 3 Seconds) ')
cvar_noBlock          = config.cvar('cvar_noBlock',            1, 'Turn Noblock on (1 = ON / 0 = OFF) (Default = 1)')
cvar_endRound         = config.cvar('cvar_endRound',           1, 'Turn End Round on (1 = ON / 0 = OFF) (Default = 1)')
cvar_popup            = config.cvar('cvar_popup',              1, 'Turn popup on (1 = ON / 0 = OFF) (Default = 1)')
config.text('\n')

config.write()
##############################
def load():
    #config.execute()
    
    enterGame = popuplib.create('enterPopup')
    enterGame.addline('~Welcome to %s\'s Server~'%cvar_serverTag)
    enterGame.addline('----------------------')
    enterGame.addline('Thank you for choosing to play here at %s\'s server.'%cvar_serverTag)
    enterGame.addline('If you have any questions please contact a %s member or admin.'%cvar_serverTag)
    enterGame.addline(' ')
    enterGame.addline('We are running \'EzProtect\'')
    enterGame.addline('Download at: ' +info.url)
    enterGame.addline(' ')
    enterGame.addline('----------------------')
    enterGame.addline('Author: Wolf (Wild_Dog_9)')
    enterGame.addline('Released: %s. V%s'%(info.date, info.version))
    enterGame.addline('----------------------')
    enterGame.addline('0. Close')
   
def unload():
    popuplib.delete('enterPopup')
    SpawnProtectOff(ev['userid'])

def player_activate(ev):
    if cvar_popup == 1:
        gamethread.delayed(1,popuplib.send,('enterPopup', ev['userid']))

def player_team(ev):
    if int(ev['team']) > 1:
        if cvar_respawn == 1 :
            gamethread.delayed(cvar_respawnTime, Respawn, ev['userid'])
            
def round_start(ev):
    if cvar_endRound == 1:
        gamethread.delayedname(float(ev['timelimit']), 'roundEnd', EndRound)
        es.msg('#multi', '#greenEzProtect #default- #lightgreenEnd Round: #greenON')
    elif cvar_endRound == 0:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenEnd Round: #greenOFF')
    else:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenEnd Round: #greenINVALID ENTRY')
    
    if cvar_noBlock == 1:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenNoblock: #greenON')
    elif cvar_noBlock == 0:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenNoblock: #greenOFF')
    else:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenNoblock: #greenINVALID ENTRY')
        
    if cvar_respawn == 1:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenRespawn: #greenON')
    elif cvar_respawn == 0:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenRespawn: #greenOFF')
    else:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenRespawn: #greenINVALID ENTRY')
    
    if cvar_spawnProtect == 1:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenSpawn Protect: #greenON')
    elif cvar_spawnProtect == 0:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenSpawn Protect: #greenOFF')
    else:
        es.msg('#multi', '#greenEzProtect #default- #lightgreenSpawn Protect: #greenINVALID ENTRY')

def EndRound():
    es.server.queuecmd('endround')
    gamethread.cancelDelayed('roundEnd')
        
def round_end(ev):
    SpawnProtectOff(ev['userid'])
    gamethread.cancelDelayed('roundEnd')
        
def player_spawn(ev):
    userid = ev['userid']
    team   = es.getplayerteam(userid)
    
    if cvar_noBlock == 1:
        es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
    elif cvar_noBlock == 0:
        es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)
        
    if cvar_spawnProtect == 1:
        if cvar_spawnProtectWho == 1:
            if team == 2:
                playerlib.getPlayer(userid).set('color', (255, 0, 0, 255))
            elif team == 3:
                playerlib.getPlayer(userid).set('color', (0, 0, 255, 255))
            else:
                playerlib.getPlayer(userid).set('color', (255, 255, 255, 255))
        
            es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0) 
            es.tell(userid, '#multi','#greenSpawn Protect #default- #lightgreenYou have %s seconds to leave spawn!'%cvar_spawnProtectTime)
            gamethread.delayed(cvar_spawnProtectTime, SpawnProtectOff, userid) 
        
        elif cvar_spawnProtectWho == 2 and es.getplayerteam(userid) == 2:
            playerlib.getPlayer(userid).set('color', (255, 0, 0, 255))
            es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0) 
            es.tell(userid, '#multi','#greenSpawn Protect #default- #lightgreenYou have %s seconds to leave spawn!'%cvar_spawnProtectTime)
            gamethread.delayed(cvar_spawnProtectTime, SpawnProtectOff, userid) 
        
        elif cvar_spawnProtectWho == 3 and es.getplayerteam(userid) == 3:
            playerlib.getPlayer(userid).set('color', (0, 0, 255, 255))
            es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 0) 
            es.tell(userid, '#multi','#greenSpawn Protect #default- #lightgreenYou have %s seconds to leave spawn!'%cvar_spawnProtectTime)
            gamethread.delayed(cvar_spawnProtectTime, SpawnProtectOff, userid) 
            

def SpawnProtectOff(userid):    
    playerlib.getPlayer(userid).set('color', (255, 255, 255, 255))
    es.setplayerprop(userid, 'CBasePlayer.m_lifeState', 512) 
    es.tell(userid, '#multi','#greenSpawn Protect #default- #lightgreenYou are no longer protected')

def player_death(ev):
    userid = ev['userid']
    
    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
    
    if cvar_respawn == 1:
        gamethread.delayed(cvar_respawnTime, Respawn, userid)

def Respawn(userid):
    es.server.queuecmd('est_spawn %s'%userid)
    es.tell(userid, '#multi', '#greenRespawn #default- #lightgreenYou have been respawned!')